import { Draft } from 'immer';
import React from 'react';
export declare type Action<P, T = string> = {
    type: T;
    payload: P;
};
export declare type Dispatch<T extends {
    useDispatch?: any;
}> = ReturnType<T['useDispatch']>;
export declare type Selector<T> = T extends {
    useSelector: (selector: (state: infer S) => any) => any;
} ? (state: S) => any : never;
export declare type Reducer<T, P> = (state: Draft<T>, action: Action<P, string>) => void;
declare type PayloadParams<T> = T extends (a: any, action: {
    type: any;
    payload: infer P;
}) => any ? P : never;
export declare function createKit<T, R extends {
    [key: string]: Reducer<T, any>;
}>({ initialState, reducers, }: {
    initialState: T;
    reducers: R;
}): {
    Context: import("use-context-selector").Context<any>;
    Provider: React.FC<{
        children?: React.ReactNode;
    }>;
    useSelector: <RR>(selector: (state: T) => RR) => RR;
    useDispatch: () => <T_1 extends keyof R>(_: Action<PayloadParams<R[T_1]>, T_1>) => void;
};
export {};
